/*
 * GameManager.java
 *
 * Created on 5 ?????? 2549, 13:44 ?.
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package th.ac.chula.eng.cp.pm;

import java.awt.MediaTracker;
import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Random;
import javax.swing.ImageIcon;

/**
 *
 * @author Administrator
 */
/*
 * class GameManager  class 觨ҧ object ǺôԹ仢ͧա÷ӧҹҧ ѧ
 * 1. ׹Ҵҹ Ѻ initialize ҢͧԵ  
 * 2. ҧҹ仾Ѻ intialize   currentStageLevel
 * 3. ǨͺҼҹҹѧ
 * 4. Ǩͺٻ͡ Ңͧѹ
 * 5. Ǩͺ Game over ѧ 
 *  
 * ҧ object ͧ class ¡ method createGameManager() ᷹ new 
 */
public class GameManager {
	
    // int ͡ӹǹٻ ö͡ҡش ( 㹷 5 ٻʹҹ )
    public static final int MAX_ICON_GENERATEABLE = 5;
    
    // Data structure ѺҧҾѺҢͧѹ 
    private Map matchIcons = null;
    
    // int кҵ͹ҹ 
    private int level = 1;
    
    // ӹǹ
    private int score = 0;
    
    // ӹǹԵ
    private int life = 3;
    
    // ҧԧ֧ stageLevel Ѩغѹ 
    private StageLevel currentStageLevel = null;
    
    private static GameManager manager = null;

    // method ͢ object GameManager ( ¡ method ᷹ new object  )
    public static GameManager createGameManager() throws GameException{
        if(manager == null)
            manager = new GameManager();
        
        return manager;
    }
    
    /** Creates a new instance of GameManager */
    private GameManager() throws GameException {        
        initializeMap();
    }

    // method ˹ initialize Map ͨѺҾѺҢͧѹ ( matchIcons  Map 纤ͧӾҷШ ) 
    private void initializeMap() throws GameException {
        if(matchIcons == null){
            matchIcons = new LinkedHashMap();
            
            matchIcons.put(getImageIcon("/resource/image/coloredicon/clock_color.gif"),getImageIcon("/resource/image/shadowedicon/clock_shadow.gif"));
            matchIcons.put(getImageIcon("/resource/image/coloredicon/drum_color.gif"),getImageIcon("/resource/image/shadowedicon/drum_shadow.gif"));
            matchIcons.put(getImageIcon("/resource/image/coloredicon/guitar_color.gif"),getImageIcon("/resource/image/shadowedicon/guitar_shadow.gif"));
            matchIcons.put(getImageIcon("/resource/image/coloredicon/mascot_color.gif"),getImageIcon("/resource/image/shadowedicon/mascot_shadow.gif"));
            matchIcons.put(getImageIcon("/resource/image/coloredicon/plier_color.gif"),getImageIcon("/resource/image/shadowedicon/plier_shadow.gif"));            
            matchIcons.put(getImageIcon("/resource/image/coloredicon/tennis_color.gif"),getImageIcon("/resource/image/shadowedicon/tennis_shadow.gif"));            
            matchIcons.put(getImageIcon("/resource/image/coloredicon/wrench_color.gif"),getImageIcon("/resource/image/shadowedicon/wrench_shadow.gif"));
            
        }
    }
    
    // method ŴٻҾ ҡ string ˹
    private ImageIcon getImageIcon(String string) throws GameException {
        try{
            return new ImageIcon(getClass().getResource(string));
        }catch(NullPointerException ex){
                throw new GameException("Unable to load image from path : "+string);
            }
    }
    
    // method  initialize  ( Ţҹ ( ҹá = 1 ) ӹǹԵ ( 3 )  ( 0 ) )  ׹Ҵҹá initialize º
    public StageLevel start(){
        level = 1;
        life = 3;
        score = 0;
        currentStageLevel = startLevel(level);
        return currentStageLevel;
    }

    //Override this Method to create your own stage level rules;
    protected StageLevel startLevel(int level) {
        
        Map levelMap = generateRandomIcons(MAX_ICON_GENERATEABLE);
        
        Random r= new Random(System.currentTimeMillis());
        
        return new RandomIconStage(level, levelMap,r.nextInt(4)+1);
        
    }
    
    // method ͧٻҢͧѹҨӹǹҡѺ i Ѻ stage ¨͡ҡ matchIcons ( matchIcons 繷纤ͧҡѺҾ  )
    private Map generateRandomIcons(int i) {
        if(i > matchIcons.size())
            throw new IllegalArgumentException("i exceed max size : " +i+" > "+matchIcons.size());
        
        Map levelMap = new LinkedHashMap();
        Random rand = new Random(System.currentTimeMillis());
        
        List keyList = new ArrayList(matchIcons.keySet());
        
        while(levelMap.size() < i){
            int n = rand.nextInt(keyList.size());
            levelMap.put(keyList.get(n),matchIcons.get(keyList.get(n)));
            keyList.remove(n);            
        }
        
        return levelMap;
    }

    
    /* method ͵Ǩͺ ҹ鹼ҹѧ ҡҹ score ա 3 Եա 1  return  ture
              ҡѧҹ return  false */ 
    public boolean isCompleteLevel() {
        boolean result = currentStageLevel.complete();
        if(result){
            score+=3;
            if(level%3==0)life++;
        }
        
        return result;
    }
    
    // method ҧҹ ( ¡ method ͼҹҹѨغѹ )  currentStageLevel ж١ҡѺҹ价 initialize º
    public void nextLevel(){
        if(!isGameOver())
            currentStageLevel = startLevel(++level);
        
        else currentStageLevel = new GameOverStage();
    }
 
    /* method ͵Ǩͺ ٻ͡Ңͧѹ 
   	      ҡ return true   score 1
              ҡ return false Ŵ score  Եŧ 1 */         
    public boolean selectItem(ImageIcon icon) {
        boolean result=currentStageLevel.select(icon);
        
        if(result) score++;
        else{
            score--;
            life--;
            startLevel(level);
        }
        
        return result;
    }

    public int getScore() {        
        return score;
    }
    
    public void resetScore(){
        score=0;
    }
    
    void setScore(int score){
        this.score = score;
    }
    
    public int getLife() {
        return life;
    }
    
    void setLife(int life){
        this.life = life;
    }
    
    //Ǩͺ  over ѧ
    public boolean isGameOver(){
        return life <= 0;
    }
    
    public StageLevel getCurrentStageLevel(){
    	return currentStageLevel;
    }


}
